HDU1595 find the longest of the shortest(最短路)

来源:互联网 发布:js获取地址 编辑:程序博客网 时间:2024/03/29 14:36

find the longest of the shortest

Time Limit: 1000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3055    Accepted Submission(s): 1110


Problem Description
Marica is very angry with Mirko because he found a new girlfriend and she seeks revenge.Since she doesn't live in the same city, she started preparing for the long journey.We know for every road how many minutes it takes to come from one city to another.
Mirko overheard in the car that one of the roads is under repairs, and that it is blocked, but didn't konw exactly which road. It is possible to come from Marica's city to Mirko's no matter which road is closed.
Marica will travel only by non-blocked roads, and she will travel by shortest route. Mirko wants to know how long will it take for her to get to his city in the worst case, so that he could make sure that his girlfriend is out of town for long enough.Write a program that helps Mirko in finding out what is the longest time in minutes it could take for Marica to come by shortest route by non-blocked roads to his city.
 

Input
Each case there are two numbers in the first row, N and M, separated by a single space, the number of towns,and the number of roads between the towns. 1 ≤ N ≤ 1000, 1 ≤ M ≤ N*(N-1)/2. The cities are markedwith numbers from 1 to N, Mirko is located in city 1, and Marica in city N.
In the next M lines are three numbers A, B and V, separated by commas. 1 ≤ A,B ≤ N, 1 ≤ V ≤ 1000.Those numbers mean that there is a two-way road between cities A and B, and that it is crossable in V minutes.
 

Output
In the first line of the output file write the maximum time in minutes, it could take Marica to come to Mirko.
 

Sample Input
5 61 2 41 3 32 3 12 4 42 5 74 5 16 71 2 12 3 43 4 44 6 41 5 52 5 25 6 55 71 2 81 4 102 3 92 4 102 5 13 4 73 5 10
 

Sample Output
111327

http://acm.split.hdu.edu.cn/showproblem.php?pid=1595

题意 给你很多条路 但是这些路中有一条在修不能用 去掉一条路之后求之中最短路中最长的那条

如果你每条边都去掉一次用dijkstra肯定超时 

先求出最短路再 在最短路上一条条去边

加了一个记录路径的操作

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;#define inf 0x3f3f3f3fint ap[1010][1010];int pre[1010];int dis[1010],vis[1010];int n,m;void dijkstra(int k){    int i,j,u;    memset(vis,0,sizeof(vis));    vis[1]=1;    for(i=1; i<=n; i++)    {        dis[i]=ap[1][i];        if(k) pre[i]=1;    }    for(i=1; i<n; i++)    {        int  MIN=inf;        for(j=1; j<=n; j++)            if(!vis[j]&&dis[j]<MIN)            {                MIN=dis[j];                u=j;            }        vis[u]=1;        for(j=1; j<=n; j++)            if(ap[u][j]<inf&&dis[j]>dis[u]+ap[u][j]&&!vis[j])            {                dis[j]=dis[u]+ap[u][j];                if(k) pre[j]=u;            }    }}int main(){    int i,j,a,b,c,u,w,maxn;    while(scanf("%d%d",&n,&m)!=EOF)    {        for(i=1; i<=n; i++)            for(j=1; j<=n; j++)                if(i==j) ap[i][j]=0;                else  ap[i][j]=inf;        while(m--)        {            scanf("%d%d%d",&a,&b,&c);            ap[a][b]=ap[b][a]=c;        }        dijkstra(1);        pre[1]=-1;        maxn=0;        //printf("%d\n",dis[n]);        w=n;        for(i=pre[n]; i!=-1;i=pre[i])        {            int t=ap[i][w];            ap[w][i]=ap[i][w]=inf;            dijkstra(0);            maxn=max(maxn,dis[n]);            ap[w][i]=ap[i][w]=t;            w=i;        }        printf("%d\n",maxn);    }    return 0;}


0 0